POJ 1015 Jury Compromise 动态规划

Description

In Frobnia, a far-away country, the verdicts in court trials are determined by a jury consisting of members of the general public. Every time a trial is set to begin, a jury has to be selected, which is done as follows. First, several people are drawn randomly from the public. For each person in this pool, defence and prosecution assign a grade from 0 to 20 indicating their preference for this person. 0 means total dislike, 20 on the other hand means that this person is considered ideally suited for the jury.
Based on the grades of the two parties, the judge selects the jury. In order to ensure a fair trial, the tendencies of the jury to favour either defence or prosecution should be as balanced as possible. The jury therefore has to be chosen in a way that is satisfactory to both parties.
We will now make this more precise: given a pool of n potential jurors and two values di (the defence's value) and pi (the prosecution's value) for each potential juror i, you are to select a jury of m persons. If J is a subset of {1,..., n} with m elements, then D(J ) = sum(dk) k belong to J
and P(J) = sum(pk) k belong to J are the total values of this jury for defence and prosecution.
For an optimal jury J , the value |D(J) - P(J)| must be minimal. If there are several jurys with minimal |D(J) - P(J)|, one which maximizes D(J) + P(J) should be selected since the jury should be as ideal as possible for both parties.
You are to write a program that implements this jury selection process and chooses an optimal jury given a set of candidates.

Input

The input file contains several jury selection rounds. Each round starts with a line containing two integers n and m. n is the number of candidates and m the number of jury members.
These values will satisfy 1<=n<=200, 1<=m<=20 and of course m<=n. The following n lines contain the two integers pi and di for i = 1,...,n. A blank line separates each round from the next.
The file ends with a round that has n = m = 0.

Output

For each round output a line containing the number of the jury selection round ('Jury #1', 'Jury #2', etc.).
On the next line print the values D(J ) and P (J ) of your jury as shown below and on another line print the numbers of the m chosen candidates in ascending order. Output a blank before each individual candidate number.
Output an empty line after each test case.

Sample Input

4 2
1 2
2 3
4 1
6 2
0 0 

Sample Output

Jury #1
Best jury has value 6 for prosecution and value 4 for defence:
2 3 

Hint

If your solution is based on an inefficient algorithm, it may not execute in the allotted time.

Source

 

    在遥远的国家佛罗布尼亚,嫌犯是否有罪,须由陪审团决定。陪审团是由法官从公众中挑选的。先随机挑选n 个人作为陪审团的候选人,然后再从这n 个人中选m 人组成陪审团。选m 人的办法是:控方和辩方会根据对候选人的喜欢程度,给所有候选人打分,分值从0 到20。为了公平起见,法官选出陪审团的原则是:选出的m 个人,必须满足辩方总分和控方总分的差的绝对值最小。如果有多种选择方案的辩方总分和控方总分的之差的绝对值相同,那么选辩控双方总分之和最大的方案即可。最终选出的方案称为陪审团方案。
    为叙述问题方便,现将任一选择方案中,辩方总分和控方总分之差简称为“辩控差”,辩方总分和控方总分之和称为“辩控和”。第i 个候选人的辩方总分和控方总分之差记为V(i),辩方总分和控方总分之和记为S(i)。现用f(j, k)表示,取j 个候选人,使其辩控差为k 的所有方案中,辩控和最大的那个方案(该方案称为“方案f(j, k)”)的辩控和。并且,我们还规定,如果没法选j 个人,使其辩控差为k,那么f(j, k)的值就为-1,也称方案f(j, k)不可行。本题是要求选出m 个人,那么,如果对k 的所有可能的取值,求出了所有的f(m, k) (-20×m≤ k ≤ 20×m),那么陪审团方案自然就很容易找到了。
    问题的关键是建立递推关系。需要从哪些已知条件出发,才能求出f(j, k)呢?显然,方案f(j, k)是由某个可行的方案f(j-1, x)( -20×m ≤ x ≤ 20×m)演化而来的。可行方案f(j-1, x)能演化成方案f(j, k)的必要条件是:存在某个候选人i,i 在方案f(j-1, x)中没有被选上,且x+V(i) = k。在所有满足该必要条件的f(j-1, x)中,选出 f(j-1, x) + S(i) 的值最大的那个,那么方案f(j-1, x)再加上候选人i,就演变成了方案 f(j, k)。这中间需要将一个方案都选了哪些人都记录下来。不妨将方案f(j, k)中最后选的那个候选人的编号,记在二维数组的元素path[j][k]中。那么方案f(j, k)的倒数第二个人选的编号,就是path[j-1][k-V[path[j][k]]。假定最后算出了解方案的辩控差是k,那么从path[m][k]出发,就能顺藤摸瓜一步步求出所有被选中的候选人。初始条件,只能确定f(0, 0) = 0。由此出发,一步步自底向上递推,就能求出所有的可行方案f(m, k)( -20×m ≤ k ≤ 20×m)。实际解题的时候,会用一个二维数组f 来存放f(j, k)的值。而且,由于题目中辩控差的值k 可以为负数,而程序中数租下标不能为负数,所以,在程序中不妨将辩控差的值都加上400,以免下标为负数导致出错,即题目描述中,如果辩控差为0,则在程序中辩控差为400。

#include <iostream>
using namespace std;

int p[201],d[201],result[21];
int dp[21][801],path[21][801];

int cmp(const void *a,const void *b){
    
return *(int *)a-*(int *)b;
}

bool select(int a,int b,int i){
    
while(a>0 && path[a][b]!=i){
        b
-=p[path[a][b]]-d[path[a][b]];
        a
--;
    }

    
return (a!=0)?true:false;
}

int main(){
    
int i,j,k,a,b,n,m,origin,ca=1;
    
while(scanf("%d %d",&n,&m),n||m){
        
for(i=1;i<=n;i++)
            scanf(
"%d %d",p+i,d+i);
        memset(dp,
-1,sizeof(dp));
        memset(path,
0,sizeof(path));
        origin
=m*20;
        
for(dp[0][origin]=j=0;j<m;j++)
            
for(k=0;k<=origin*2;k++)
                
if(dp[j][k]>=0){
                    
for(i=1;i<=n;i++)
                        
if(dp[j+1][k+p[i]-d[i]]<dp[j][k]+p[i]+d[i]){
                            a
=j,b=k;
                            
if(!select(a,b,i)){
                                dp[j
+1][k+p[i]-d[i]]=dp[j][k]+p[i]+d[i];
                                path[j
+1][k+p[i]-d[i]]=i;
                            }

                        }

                }

        
for(i=origin,j=0;dp[m][i+j]<0 && dp[m][i-j]<0;j++);
        k
=dp[m][i+j]>dp[m][i-j]?i+j:i-j;
        printf(
"Jury #%d\n",ca++);
        printf(
"Best jury has value %d for prosecution and value %d for defence:\n",(dp[m][k]+k-origin)/2, (dp[m][k]-k+origin)/2);
        
for(i=1;i<=m;i++){
            result[i]
=path[m-i+1][k];
            k
-=p[result[i]]-d[result[i]];
        }

        qsort(result
+1,m,sizeof(int),cmp);
        
for(i=1;i<=m;i++)
            printf(
" %d",result[i]);
        printf(
"\n");
        printf(
"\n");
    }

    
return 0;
}


 

posted on 2009-06-23 17:08 极限定律 阅读(4532) 评论(6)  编辑 收藏 引用 所属分类: ACM/ICPC

评论

# re: POJ 1015 Jury Compromise 动态规划 2009-09-09 14:03 boa

不知道为什么这种方法uva和tju上是wa啊?难道是这两个网站不判special judge?  回复  更多评论   

# re: POJ 1015 Jury Compromise 动态规划 2010-05-06 23:03 Cre_nws

麻烦问一下" if(dp[j+1][k+p[i]-d[i]]<dp[j][k]+p[i]+d[i])"当k=0时,p[i]-d[i]如果为负值,那么会不会产生运行时错误啊?!谢啦!  回复  更多评论   

# re: POJ 1015 Jury Compromise 动态规划 2010-08-05 22:33 cxb

@Cre_nws
k应该不会取到0,因为取到0就意味着“辩控差”为负的最大,即已经到了j=m-1次循环,并且所有的陪审员都是p:0 s:20,此时k=0,并且整个循环已经结束了,这就是板主为何要将origin=m*20的原因之所在。有不对的地方,请指正~  回复  更多评论   

# re: POJ 1015 Jury Compromise 动态规划 2010-09-03 14:58 tel

效率不是很高啊  回复  更多评论   

# re: POJ 1015 Jury Compromise 动态规划 2010-10-14 19:59 songtianyi

效率已经不错了  回复  更多评论   

# re: POJ 1015 Jury Compromise 动态规划 2011-08-05 20:33 asdf

这个算法有后效性吧。就是在i的选取上。  回复  更多评论   


只有注册用户登录后才能发表评论。
网站导航: 博客园   IT新闻   BlogJava   知识库   博问   管理


<2009年6月>
31123456
78910111213
14151617181920
21222324252627
2829301234
567891011

导航

统计

常用链接

留言簿(10)

随笔分类

随笔档案

友情链接

搜索

最新评论

阅读排行榜

评论排行榜